(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["CKEditor5"] = factory();
	else
		root["CKEditor5"] = root["CKEditor5"] || {}, root["CKEditor5"]["IconifyFieldPlugin"] = factory();
})(self, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "ckeditor5/src/core.js":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = (__webpack_require__("dll-reference CKEditor5.dll"))("./src/core.js");

/***/ }),

/***/ "ckeditor5/src/ui.js":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = (__webpack_require__("dll-reference CKEditor5.dll"))("./src/ui.js");

/***/ }),

/***/ "ckeditor5/src/widget.js":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = (__webpack_require__("dll-reference CKEditor5.dll"))("./src/widget.js");

/***/ }),

/***/ "dll-reference CKEditor5.dll":
/***/ ((module) => {

"use strict";
module.exports = CKEditor5.dll;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ src)
});

// EXTERNAL MODULE: delegated ./core.js from dll-reference CKEditor5.dll
var delegated_corefrom_dll_reference_CKEditor5 = __webpack_require__("ckeditor5/src/core.js");
// EXTERNAL MODULE: delegated ./widget.js from dll-reference CKEditor5.dll
var delegated_widgetfrom_dll_reference_CKEditor5 = __webpack_require__("ckeditor5/src/widget.js");
;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/src/insert_iconify_field_command.ts

class InsertIconifyFieldCommand extends delegated_corefrom_dll_reference_CKEditor5.Command {
    execute() {
        var _a, _b;
        const { model } = this.editor;
        const config = this.editor.config.get('iconifyField');
        const query = new URLSearchParams({
            default_collection: (_a = config.defaultCollection) !== null && _a !== void 0 ? _a : '',
            collections: (_b = config.collections) !== null && _b !== void 0 ? _b : '',
        });
        // @ts-expect-error Drupal is a global variable
        const modal = Drupal.ajax({
            url: `/admin/iconify_field/menu-icons/picker?${query}`,
            dialogType: 'modal',
            dialog: {
                height: 600,
                width: 800,
            },
        });
        modal.execute();
        document.body.addEventListener('iconify-field-pick-icon', (event) => {
            const closeBtn = document.body.querySelector('.ui-dialog-titlebar-close');
            if (closeBtn)
                closeBtn.click();
            const icon = event.detail.text;
            model.change((writer) => {
                model.insertObject(createIconifyField(writer, icon), null, null, {
                    setSelection: 'on',
                });
            });
        });
    }
    refresh() {
        const { model } = this.editor;
        const { selection } = model.document;
        const position = selection.getFirstPosition();
        if (!position)
            return;
        const allowedIn = model.schema.findAllowedParent(position, 'iconifyField');
        this.isEnabled = allowedIn !== null;
    }
}
function createIconifyField(writer, icon) {
    const iconifyField = writer.createElement('iconifyField', {
        'data-icon': icon,
    });
    return iconifyField;
}

;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/src/iconify_field_editing.ts



class IconifyFieldEditing extends delegated_corefrom_dll_reference_CKEditor5.Plugin {
    static get requires() {
        return [delegated_widgetfrom_dll_reference_CKEditor5.Widget];
    }
    init() {
        this._defineSchema();
        this._defineConverters();
        this.editor.commands.add('insertIconifyField', new InsertIconifyFieldCommand(this.editor));
    }
    _defineSchema() {
        const { schema } = this.editor.model;
        schema.register('iconifyField', {
            inheritAllFrom: '$inlineObject',
            allowAttributes: [
                'data-icon',
            ],
        });
    }
    _defineConverters() {
        const { conversion } = this.editor;
        conversion.for('upcast').elementToElement({
            // model: 'iconifyField',
            view: {
                name: 'span',
                classes: 'iconify-field',
            },
            model: (viewElement, { writer }) => {
                return writer.createElement('iconifyField', {
                    'data-icon': viewElement.getAttribute('data-icon'),
                });
            },
        });
        conversion.for('dataDowncast').elementToElement({
            model: 'iconifyField',
            view: (modelElement, { writer }) => {
                return this.createIconifyFieldView(modelElement, writer);
            },
        });
        conversion.for('editingDowncast').elementToElement({
            model: 'iconifyField',
            view: (modelElement, { writer }) => {
                const element = this.createIconifyFieldView(modelElement, writer);
                return (0,delegated_widgetfrom_dll_reference_CKEditor5.toWidget)(element, writer, { label: 'Icon' });
            },
        });
    }
    createIconifyFieldView(modelElement, writer) {
        var _a;
        const icon = (_a = modelElement.getAttribute('data-icon')) !== null && _a !== void 0 ? _a : '';
        const element = writer.createContainerElement('span', {
            'class': 'iconify-field',
            'data-icon': icon,
            'style': icon ? `background-image: url(/api/iconify_field_ckeditor/icon/${icon})` : undefined,
        });
        return element;
    }
}

// EXTERNAL MODULE: delegated ./ui.js from dll-reference CKEditor5.dll
var delegated_uifrom_dll_reference_CKEditor5 = __webpack_require__("ckeditor5/src/ui.js");
;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/img/IconifyField.svg
/* harmony default export */ const IconifyField = ("<svg xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" width=\"1em\" height=\"1em\" viewBox=\"0 0 24 24\"><path fill=\"currentColor\" d=\"M20 12a8 8 0 0 0-8-8a8 8 0 0 0-8 8a8 8 0 0 0 8 8a8 8 0 0 0 8-8m2 0a10 10 0 0 1-10 10A10 10 0 0 1 2 12A10 10 0 0 1 12 2a10 10 0 0 1 10 10M10 9.5c0 .8-.7 1.5-1.5 1.5S7 10.3 7 9.5S7.7 8 8.5 8s1.5.7 1.5 1.5m7 0c0 .8-.7 1.5-1.5 1.5S14 10.3 14 9.5S14.7 8 15.5 8s1.5.7 1.5 1.5m-5 7.73c-1.75 0-3.29-.73-4.19-1.81L9.23 14c.45.72 1.52 1.23 2.77 1.23s2.32-.51 2.77-1.23l1.42 1.42c-.9 1.08-2.44 1.81-4.19 1.81\"></path></svg>\n");
;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/src/iconify_field_ui.ts



class IconifyFieldUI extends delegated_corefrom_dll_reference_CKEditor5.Plugin {
    init() {
        const { editor } = this;
        editor.ui.componentFactory.add('iconifyField', (locale) => {
            const buttonView = new delegated_uifrom_dll_reference_CKEditor5.ButtonView(locale);
            buttonView.set({
                label: editor.t('Icon'),
                icon: IconifyField,
                tooltip: true,
            });
            this.listenTo(buttonView, 'execute', () => editor.execute('insertIconifyField'));
            return buttonView;
        });
    }
}

;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/src/iconify_field.ts



class iconify_field_IconifyField extends delegated_corefrom_dll_reference_CKEditor5.Plugin {
    static get requires() {
        return [
            IconifyFieldEditing,
            IconifyFieldUI,
        ];
    }
}

;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/src/index.ts

/* harmony default export */ const src = ({
    IconifyField: iconify_field_IconifyField,
});

})();

__webpack_exports__ = __webpack_exports__["default"];
/******/ 	return __webpack_exports__;
/******/ })()
;
});